VERSION 5.00
Begin VB.Form frmEnum 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "Direct3D Sample  Sentinel Design | www.visulbasicworld.de"
   ClientHeight    =   1455
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   5865
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1455
   ScaleWidth      =   5865
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3480
      TabIndex        =   5
      Top             =   960
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4680
      TabIndex        =   4
      Top             =   960
      Width           =   1095
   End
   Begin VB.ComboBox cmbMode 
      Height          =   315
      ItemData        =   "frmEnum.frx":0000
      Left            =   1920
      List            =   "frmEnum.frx":0002
      TabIndex        =   3
      Top             =   480
      Width           =   3855
   End
   Begin VB.ComboBox cmbDriver 
      Height          =   315
      Left            =   1920
      TabIndex        =   0
      Top             =   120
      Width           =   3855
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Screen resolution:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   525
      Width           =   1560
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Rendering Device:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   150
      Width           =   1605
   End
End
Attribute VB_Name = "frmEnum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Daniel Netz
' Email: netz@home.se
'
' Bitte richten Sie sich mit Fragen nicht an den Autor,
' sondern verwenden Sie das Forum auf www.visualbasicworld.de
'
' Date: 2000-03-20
' Requirements: DX7 Library for VB, Win32 library by Patrice Scribe
'
' Use this code at your own risc!!!
'
' Note that the rendering is really fast the first second,
' this is to decide the proper frame rate...I didn't have time
' to do anything about it
'
' If you get a black screen when running it, it may be because
' you graphics card doesn't support the selected screen mode.
' You should therefore run the D3D HAl device in 640x480x16
'
' Daniel Netz, Sentinel Design

Option Explicit

Dim EnumDrivers As Direct3DEnumDevices
Dim EnumModes As DirectDrawEnumModes

Private Sub cmdCancel_Click()
    End
End Sub

Private Sub cmdOK_Click()
    
    Dim info As DDSURFACEDESC2
    
    EnumModes.GetItem cmbMode.ListIndex + 1, info
    
    ScreenResX = info.lWidth
    ScreenResY = info.lHeight
    ScreenBPP = info.ddpfPixelFormat.lRGBBitCount

    D3DGUID = D3D.GetDevicesEnum.GetGuid(cmbDriver.ListIndex + 1)
    
    Me.Hide
    Load frmMain
    Unload Me
    
End Sub


Private Sub Form_Load()
    
    Dim DDSD As DDSURFACEDESC2
    Dim info As DDSURFACEDESC2
    Dim mode640 As Integer
    
    Set DD = DX.DirectDrawCreate("")
    Set D3D = DD.GetDirect3D
    
    Set EnumDrivers = D3D.GetDevicesEnum
    Set EnumModes = DD.GetDisplayModesEnum(DDEDM_DEFAULT, DDSD)
    
    For I = 1 To EnumDrivers.GetCount
        cmbDriver.AddItem EnumDrivers.GetName(I)
    Next I
    
    'cmbDriver.ListIndex = 1
    
    For I = 1 To EnumModes.GetCount
        EnumModes.GetItem I, info
        cmbMode.AddItem info.lWidth & "x" & info.lHeight & "x" & info.ddpfPixelFormat.lRGBBitCount
        
        'find the 640x480x16 mode if possible
        cmbMode.ListIndex = I - 1
        If cmbMode.Text = "640x480x16" Then mode640 = cmbMode.ListIndex
        DoEvents
    Next I
    
    cmbMode.ListIndex = mode640
    
End Sub
